#include <stdio.h>
#include <string.h>

#define MAXB 10
#define MAXD 30
#define MAXS ((MAXB-1)*MAXD)
typedef long long int big;

static int B, D;
static big k;
static char num[MAXD];
static int sum;
static big sums[MAXS+1];

static void reset(void)
{
  memset(num, 0, sizeof(num));
}

static int inc(void)
{
  int i = 0;
  int cy = 1;
  sum = 0;
  while (i < D)
    {
      if (cy)
	num[i]++;
      cy = num[i] / B;
      num[i] = num[i] % B;
      sum += num[i++];
    }
  return !cy;
}

int main(void)
{
  FILE *fi = fopen("sbirka.in", "r");
  fscanf(fi, "%d%d%lld", &B, &D, &k);
  k--;
  fclose(fi);

  reset();
  do
    sums[sum]++;
  while (inc());

  int s = 0;
  while (k >= sums[s])
    k -= sums[s++];

  reset();
  do
    {
      if (sum == s && !k--)
	{
	  FILE *fo = fopen("sbirka.out", "w");
	  int i = D-1;
	  while (i > 0 && !num[i])
	    i--;
	  while (i >= 0)
	    fputc('0' + num[i--], fo);
	  fputc('\n', fo);
	  fclose(fo);
	  return 0;
	}
    }
  while (inc());

  fprintf(stderr, "BUG\n");
  return 1;
}
