#include <stdio.h>
#include <string.h>

#define MAXB 10
#define MAXD 30
#define MAXS ((MAXB-1)*MAXD)
typedef long long int big;

int main(void)
{
  int B, D;
  big k;
  big n[MAXD+1][MAXS+1] = { 0 };

  FILE *fi = fopen("sbirka.in", "r");
  fscanf(fi, "%d%d%lld", &B, &D, &k);
  fclose(fi);

  // Zkontrolujeme zadn
  if (B < 2 || B > MAXB || D < 1 || D > MAXD || k < 1)
    {
      fprintf(stderr, "BUG: Invalid B or D or k\n");
      return 1;
    }
  big zz = 1;
  for (int i=0; i<D; i++)
    zz *= B;
  if (zz > 1000000000000000000LL)
    {
      fprintf(stderr, "BUG: Space too large\n");
      return 1;
    }

  // Spotme vechna n[d][s]
  n[0][0] = 1;
  int S = (B-1)*D;
  for (int d=1; d<=D; d++)
    for (int s=0; s<=S; s++)
       for (int x=0; x<B && x<=s; x++)
          n[d][s] += n[d-1][s-x];
  k--;

  // Najdeme sprvn souet
  int s = 0;
  while (s <= S && k >= n[D][s])
    k -= n[D][s], s++;
  if (s > S)
    {
      fprintf(stderr, "BUG: Invalid k\n");
      return 1;
    }

  // Dopotme slice a rovnou je vypeme
  FILE *fo = fopen("sbirka.out", "w");
  int z = 1;  // Zatm sam nuly
  for (int d=D; d>1; d--)
    {
      int x = 0;
      while (x < B-1 && n[d-1][s-x] <= k)
        {
	  k -= n[d-1][s-x];
	  x++;
	}
      if (x || !z)
	{
	  fputc('0' + x, fo);
	  z = 0;
	}
      s -= x;
    }
  fprintf(fo, "%d\n", (int)s);
  fclose(fo);
  return 0;
}
